#!/usr/bin/perl -w

##########################################################################
# Perl Gstebuch (Quick and dirty guestbook)
# Codename: qnd-gb
# Version: 1.1 
# Autor: Christoph Maciejewski
# URL: http://chrm.info/internet/perl.html
#
# Dieses Programm ist freie Software. Sie knnen es unter
# den Bedingungen der GNU General Public License, wie von der
# Free Software Foundation herausgegeben, weitergeben und/oder
# modifizieren, entweder unter Version 2 der Lizenz oder (wenn
# Sie es wnschen) jeder spteren Version.
#
# Lizenztext: http://chrm.info/software/gpl_deutsch.html
#
# Dieses Skript liest eine zeichenbegrenzte Datei (gbuch.csv) mit Eintrgen 
# ein und schreibt sie HTML-formatiert auf die Standardausgabe. 
##########################################################################

use CGI;
use CGI::Carp qw(fatalsToBrowser);
use Digest::MD5 qw(md5 md5_hex md5_base64);


#-------------------- Die folgenden Variablen knnen Sie bel. anpassen ----------------------

$HTMLTitle = "Gaestebuch";  # Titel
$Topic = "G&auml;stebuch";  # Ueberschrift
$Text = "\
Dieses in Perl geschriebene G&auml;stebuch kann unter \
<a href=\"http://chrm.info/internet/perl.html\">http://chrm.info</a> heruntergeladen werden.<br> \
Hier k&ouml;nnt Ihr das gute St&uuml;ck testen.<br><br> \
Sollte der Beitrag nach dem Abschicken nicht sofort sichtbar sein, benutzt bitte die reload-Funktion des Browsers! \
";                          # Begruessungstext

####### anti-spam #######
$spamText = "Sorry, Sie sind ein Spammer!"; # Spammer Begruessung
$wrongResult = "Sorry, falsches Ergebnis oder Sie sind ein Spammer!"; # Spam-Test nicht bestanden
$timeslot = 600;            # Zeitfenster frs Verfassen eines Eintrags (in Sekunden)
#########################

$logIP = 1;                 # IPs der Besucher loggen? 1:ja 0:nein
$numOfURLs = 2;             # Maximale Anzahl an erlaubten URLs im Eintrag
$AnzahlS = 6;               # Wieviele Datenstze sollen auf einer Seite ausgegeben werden?
$Trenner = (";");           # Trennzeichen der Datenstze
$Color1 =("74C4D8");        # Fr die Farbe der ersten Zeile (Datum) und des Formulars
$Color2 =("B1F2FF");        # Fr die Farbe der restlichen Zeilen
$BGColor =("FFFFFF");       # Hintergrund des Dokumentes
$Mail = 2;		    # Zeile fr den Link, zB: eMail oder Homepage (beginned bei 0)
$FILE = "gbuch.csv";        # Datei fr Eintrge

#--------------------------------------------------------------------------------------------


my $cgi = new CGI;
my $NAME = $cgi->param("NAME");
my $EMAIL = $cgi->param("EMAIL");
my $TEXT = $cgi->param("TEXT");
my $CHECK = $cgi->param("RESULTCHECK");
my $RESULTGET = $cgi->param("RESULTGET");
my $TSGET = $cgi->param("TSGET");

my $IS_SPAMMER="YES";

my @ROWS_TOPICS = ("Date", "Name", "eMail", "Text");

$NAME =~ s/</&lt;/g;
$EMAIL =~ s/</&lt;/g;
$TEXT =~ s/<br>/[br]/g;
$TEXT =~ s/<b>/[b]/g;
$TEXT =~ s/<\/b>/[\/b]/g;
$TEXT =~ s/</&lt;/g;

my $PAGE = $cgi->param("PAGE");

# Check for spammers
my $TASK = ""; # String
my $RESULT = ""; # MD5 of task
my $TS = time();


#--------------------------------------------------------------------------------------------
# Draws HTML-Head
sub drawHTMLHead() {
    print "Content-type: text/html\n\n";
    print "<html><head><title>$HTMLTitle</title>\n";

    print << "__END0__";
  <style type="text/css">
    body { background-color:$BGColor; }
    td.cell1 { background-color:$Color1; border-color:#000000; border-style:solid; border-width:1px; }
    td.cell2 { background-color:$Color2; border-color:#000000; border-style:none; border-width:1px; }    
  </style>

  <!-- Generated by qnd-gb (c) by chrm.info 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.  
  --> 
  
  <h1 align=\"center\">$Topic</h1>
  <div align=\"center\">$Text<br>
  <br><a href="#verfassen">Eintrag verfassen</a><br><br></div>
__END0__

    print "</head>\n<body>\n";
}

# Draws HTML-Tail
sub drawHTMLTail() {
  print "<br><br><br><div align=\"center\">\n";
  print "<form name=\"Formular\" action=\"gbuch.pl\" method=\"post\" >\n";
  print "<h3><a NAME=\"verfassen\"></a>Eintrag verfassen:</h3>\n";
 
  getTask(); 
  print "<input type=hidden name=\"RESULTCHECK\" value=\"$RESULT\">\n";
  print "<input type=hidden name=\"TSGET\" value=\"$TS\">\n";

  print "<table BORDER=\"0\" BGCOLOR=\"#$Color1\" cellspacing=\"0\" cellpadding=\"0\"><tr><td>&nbsp;Name:</td><td><input name=\"NAME\" size=\"30\"></td></tr>\n";
  print "<tr><td>&nbsp;E-Mail:</td><td><input name=\"EMAIL\" size=\"30\"></td></tr>\n";
  print "<tr><td>&nbsp;$TASK</td><td><input name=\"RESULTGET\" size=\"10\"></td></tr>\n";
  print "<tr><td></td><td><font size=-1>Spam-Schutz. Bitte Ergebnis angeben!</font></td></tr>\n";
  print "<tr><td></td><td>&nbsp;</td></tr>\n";
  print "<tr><td>&nbsp;Text:</td><td><textarea name=\"TEXT\" rows=\"5\" cols=\"45\"></textarea></td></tr>\n";
  print "<tr><td>&nbsp;</td><td><input type=\"submit\" value=\"Eintrag Senden\">\n<input type=\"reset\" value=\"Felder l&ouml;schen\"></td></tr></table></form>\n";
  print "</div>";
  #print "<A HREF=\"http://validator.w3.org/check?uri=http://chrm.info/cgi-bin/gbuch_folding/gbuch.pl\"><IMG SRC=\"../../bilder/valid-html401.png\" ALT=\"Valid HTML 4.01!\" height=\"31\" width=\"88\" BORDER=\"0\"></A>";
  print "</body>\n</html>";
}

# Adds a new Entry
sub addEntry() {
    if($IS_SPAMMER eq "YES") {
         print "$wrongResult</body></html>";
         exit 0;
     }

     my @testArray = split(/http:/, $TEXT);
     if($#testArray > $numOfURLs) {
         print "$spamText</body></html>";
         exit 0;
     }

     @testArray = split(/href=/, $TEXT);
     if($#testArray > $numOfURLs) {
         print "$spamText</body></html>";
         exit 0;
     }
     
     open(ENTRIES, ">> $FILE") || die "Can't load etries-files: $FILE";

     $NAME =~ s/$Trenner/####/g;
     $EMAIL =~ s/$Trenner/####/g;
     $TEXT =~ s/$Trenner/####/g;
     $TEXT =~ s/[\n\r]/ /g;

     # IP User Data
     my @gettheip = split(/\./,$ENV{'REMOTE_ADDR'});
     my $IP = "$gettheip[0].$gettheip[1].$gettheip[2].$gettheip[3]";

     if($logIP == 0) {
        $IP = "---";
     }

     my $line = "".localtime(time())."$Trenner".$NAME."$Trenner".$EMAIL."$Trenner".$TEXT." ";
     my $userInfo = "<!--$IP, $ENV{'HTTP_USER_AGENT'}-->\n";
     $userInfo =~ s/$Trenner/####/g;
     
     my $all = $line.$userInfo;
     print ENTRIES $all;
     close ENTRIES;
}

# Show entries
sub showEntries($) {
    my $_page = shift;
    
    open(ENTRIES, "< $FILE") || die "Can't load etries-files: $FILE";
    my @fileContent;
    my @row;
    my $cnt = 0;
    my $tmpPage = 0;

    while(<ENTRIES>) {
        unshift(@fileContent, $_);
    }
    
    print "<table border=\"0\" width=\"100%\">\n";
    foreach(@fileContent) {
        if($tmpPage < ($_page * $AnzahlS)) {
            $tmpPage++;
            next;
        }
        
        @row = split(/$Trenner/, $_);
        print "  <tr><td><table border=\"0\" width=\"100%\">\n";
        $cnt = 0;
        
        foreach(@row) {
            $_ =~ s/\[br\]/<br>/g;
            $_ =~ s/\[b\]/<b>/g;
            $_ =~ s/\[\/b\]/<\/b>/g;
            $_ =~ s/####/$Trenner/g;
           
            my $showTxt = $_;

            if($cnt == $Mail) {
                $showTxt = "<a href=\"mailto:$showTxt\">$showTxt</a>";
            } 
            
            if($cnt == 0) {
                print "   <tr><td width=\"10%\" class=\"cell1\">".$ROWS_TOPICS[$cnt]."</td><td class=\"cell1\">$showTxt</td></tr>\n";
            } else {
                print "   <tr><td width=\"10%\" class=\"cell1\">".$ROWS_TOPICS[$cnt]."</td><td class=\"cell2\">$showTxt</td></tr>\n";   
            }
            $cnt++;
        }
        
        print "  </table></td></tr>\n";
        $tmpPage++;

        if($tmpPage > ($_page * $AnzahlS + $AnzahlS)) {
            close ENTRIES;
            drawEndline($_page);
            return;
        }
    }
    
    close ENTRIES;
    drawEndline($_page);
}

# Draws some end-lines
sub drawEndline($) {
    $_page = shift;

    print "</table>\n";
    
    my $prev = $_page - 1;
    if ($prev < 0) {
        $prev = 0;
    }
    my $next = $_page + 1;
   
    if($_page == 0) {
        print "<div align=\"center\"><hr><br><a href=\"gbuch.pl?PAGE=$next\" title=\"Weitere\">[>>]</a><br><br><hr></div>\n";
    } else {
        print "<div align=\"center\"><hr><br><a href=\"gbuch.pl?PAGE=$prev\">[<<]</a>&nbsp;<a href=\"gbuch.pl?PAGE=$next\">[>>]</a><br><br><hr></div>\n";
    }
}


# Gets a MD5Hash of gives string
sub getMD5($) {
    my $_in = shift;
    $digest = md5_hex($_in);
    return $digest; 
}

# Get post task
sub getTask() {
    my $lower=1; 
    my $upper=9; 
    my $random1 = int(rand( $upper-$lower+1 ) ) + $lower; 
    my $random2 = int(rand( $upper-$lower+1 ) ) + $lower; 
    my $result = $random1+$random2;
    $RESULT = getMD5($result);
    $TASK = "$random1&nbsp;+&nbsp;$random2&nbsp;=&nbsp;";
}


#--------------------------------------------------------------------------------------------
# Main
#--------------------------------------------------------------------------------------------

if(getMD5($RESULTGET) eq $CHECK && $TSGET > (time() - $timeslot) && $TSGET < time()) {
    $IS_SPAMMER = "NO";
}

drawHTMLHead();

if($NAME && $TEXT) {
    addEntry();
}

showEntries($PAGE);
drawHTMLTail();

exit 0;
